
( BADNOP dev env for PICmicro 18fxx2 )

( ********** COMPILER SOURCE  ************ )


( TODO: add macro extension to create host code )

: var create 0 ,, ;             ( initialized variable )
: allot for 0 ,, next ;         ( initialized table )

( create a stack: bottom contains top pointer 
stacks grow upward in memory
popping an empty stack returns 0
pushing a full stack resets the stack, then pushes )

: stack-default-size 16 ;       ( default stack size )
: stack				( create a stack )
    create 			( create tos pointer )
    free ,,                     ( make TOS points to itself: empty stack )
    stack-default-size allot ; 	( create stack buffer )

: stack-reset dup ! ;		( make TOS point to itself )
: stack-elements dup @ - ;      ( get nb of elements on stack )
  

: stack-empty?
    stack-elements 0 = ;

: stack-full?
    stack-elements stack-default-size = ;

: drop0 drop 0 ;

: stack-top                     ( get value from top of stack )
    dup stack-empty? pass drop0
    @ @ ;

: stack-push
    dup stack-full? ? stack-reset
    dup >r			( save address of stack pointer )
    @ 1 +                       ( deref and pre-inc )
    dup r> !	                ( store new value of stack pointer )
    ! ;                         ( store value on new TOS )

: stack-pop
    dup stack-empty? pass drop0
    dup >r                      ( save address of stack pointer )
    @ dup >r                    ( get TOS ptr + save value )
    @                           ( get value on TOS )
    r> 1 - r> ! ;               ( post-dec stack pointer and store it )
	
: stack-drop stack-pop drop ;



